@echo off
rem MOVEWINDOW.BAT - Example program of Window.exe auxiliary command
rem Antonio Perez Ayala

setlocal EnableDelayedExpansion

rem Define keyName=keyValue of used keys
set keyName=
for %%a in ("EnterKey=13" "DownArrow=-80" "LeftArrow=-75" "RightArrow=-77"       "UpArrow=-72"
            "Ctrl_DownArrow=-145" "Ctrl_LeftArrow=-115"   "Ctrl_RightArrow=-116" "Ctrl_UpArrow=-141"
            "Alt_DownArrow=-160"  "Alt_LeftArrow=-155"    "Alt_RightArrow=-157"  "Alt_UpArrow=-152" ) do (
   set %%a
)

rem Get window size, font size, and current window position
Window GSize
call :GetCoords GWinWidth= GWinHeight=
Window Size
call :GetCoords CWinCols=  CWinLines=
set /A GFontWidth=GWinWidth/CWinCols, GFontHeight=GWinHeight/CWinLines
Window GPos
call :GetCoords GWinX=     GWinY=

rem Grow window buffer to fit 1.5 times current wide
set Cols=
set Lines=
for /F "skip=2 tokens=2" %%a in ('mode con') do (
   if not defined Lines (
      set Lines=%%a
   ) else if not defined Cols (
      set Cols=%%a
   )
)
set /A Cols=Cols*3/2
mode con cols=%Cols% lines=%Lines%

echo/
echo - Arrow keys change window size.
echo - Ctrl-Arrow keys move window in character-wide steps.
echo - Alt-Arrow keys move window in one pixel steps.
echo/
echo Press Enter when ready

rem Define actions per key
rem (key values may directly be placed in indexes, but this way is clearer)
set action[%DownArrow%]=CWinLines+=1
set action[%UpArrow%]=CWinLines-=1
set action[%RightArrow%]=CWinCols+=1
set action[%LeftArrow%]=CWinCols-=1
set action[%Ctrl_DownArrow%]=GWinY+=GFontHeight
set action[%Ctrl_UpArrow%]=GWinY-=GFontHeight
set action[%Ctrl_RightArrow%]=GWinX+=GFontWidth
set action[%Ctrl_LeftArrow%]=GWinX-=GFontWidth
set action[%Alt_DownArrow%]=GWinY+=1
set action[%Alt_UpArrow%]=GWinY-=1
set action[%Alt_RightArrow%]=GWinX+=1
set action[%Alt_LeftArrow%]=GWinX-=1

:updateWindow
Window  Size=%CWinCols%,%CWinLines%  GPos=%GWinX%,%GWinY%

:nextKey
GetKey
if defined action[%errorlevel%] set /A !action[%errorlevel%]! & goto updateWindow
if %errorlevel% neq %EnterKey% goto nextKey
goto :EOF


:GetCoords Cols= Lines=
set /A "%1=%errorlevel%&0xFFFF, %2=(%errorlevel%>>16)&0xFFFF"
exit /B

